﻿// MinCMS noninvasive ASP.NET WebForms System
// ----------------------------------------------------
// License: Microsoft Reciprocal License (Ms-RL)
// Version: 1.0.0.0
// Initial Development: Prosodev - Software Company / August 2013 / V 1.0.0.0

namespace MinCms.Core
{
    using System;
    using System.Web;

    public sealed class MinCmsCompressionModule : IHttpModule
    {
        #region Explicit Interface Methods

        void IHttpModule.Dispose()
        {
        }

        void IHttpModule.Init(HttpApplication context)
        {
            context.BeginRequest += ContextBeginRequest;
        }

        #endregion

        #region Methods

        private static void ContextBeginRequest(object sender, EventArgs e)
        {
            var app = sender as HttpApplication;

            if (app != null)
            {
                if (MinCms.Instance.Properties.GetValue("HtmlCompression", true) && !MinCms.Instance.EditMode)
                {
                    if (app.Request.RawUrl.ToLower().Contains(".aspx"))
                    {
                        app.Response.Filter = new MinCms.Compressor(app.Response.Filter);
                    }
                }
            }
        }

        #endregion
    }
}