﻿// MinCMS noninvasive ASP.NET WebForms System
// ----------------------------------------------------
// License: Microsoft Reciprocal License (Ms-RL)
// Version: 1.0.0.0
// Initial Development: Prosodev - Software Company / August 2013 / V 1.0.0.0

namespace MinCms.Core.Plugins
{
    using System.Web.UI;

    public sealed class LoadControl : IMinCmsPlugin
    {
        #region Public Properties

        public bool AdminPageVisible
        {
            get { return false; }
        }

        public string FullTypeName
        {
            get { return "MinCms.Core.Ui.MinCmsControlGenerator"; }
        }

        #endregion

        #region Public Methods and Operators

        public string Description
        {
            get
            {
                return "Load controls without registration in aspx.";
            }
        }

        public Control GetAdminControl(Page page, MinCms.IFile currentFile)
        {
            return null;
        }

        public string GetAdminDisplayName()
        {
            return "LoadControl";
        }

        public string GetAdminPageIncludes()
        {
            return string.Empty;
        }

        #endregion
    }
}