﻿// MinCMS noninvasive ASP.NET WebForms System
// ----------------------------------------------------
// License: Microsoft Reciprocal License (Ms-RL)
// Version: 1.0.0.0
// Initial Development: Prosodev - Software Company / August 2013 / V 1.0.0.0

namespace MinCms.Core.Plugins
{
    using System;
    using System.Web.UI;
    using Ui;

    public sealed class MinCmsControl : IMinCmsPlugin
    {
        #region Public Properties

        public bool AdminPageVisible
        {
            get { return true; }
        }

        public string Description
        {
            get { return "Default control to place on every page."; }
        }

        public string FullTypeName
        {
            get { return "MinCms.Core.Ui.MinCmsControl"; }
        }

        #endregion

        #region Public Methods and Operators

        public Control GetAdminControl(Page page, MinCms.IFile currentFile)
        {
            var editFile = (MinCmsEditor)page.LoadControl("~/Core/Ui/MinCmsEditor.ascx");
            editFile.TextData = Ui.MinCmsControl.GetIncludes(null);
            editFile.SaveName = "[MinCmsIncludes]";
            editFile.SaveData += (a, b) =>
            {
                MinCms.Instance.Properties["MinCmsControl_Configuration"] = editFile.TextData;
                MinCms.Instance.ResetFiles();
                MinCms.Instance.ClearMinCmsPluginConfiguration();
            };

            editFile.Quit += (a, b) => MinCms.Instance.ClearMinCmsPluginConfiguration();
            return editFile;
        }

        public string GetAdminDisplayName()
        {
            return "MinCmsControl";
        }

        public string GetAdminPageIncludes()
        {
            return "<meta charset=\"utf-8\">" + Environment.NewLine +
                   "<meta name=\"viewport\" content=\"width=device-width, initial-scale=1.0\">" + Environment.NewLine +
                   "<!--[if lt IE 9]>" + Environment.NewLine +
                   "   <script src=\"bootstrap/assets/js/html5shiv.js\"></script>" + Environment.NewLine +
                   "   <script src=\"bootstrap/assets/js/respond.min.js\"></script>" + Environment.NewLine +
                   "<![endif]-->" + Environment.NewLine +
                   "<link href=\"bootstrap/css/bootstrap.min.css\" rel=\"stylesheet\">" + Environment.NewLine +
                   "<script src=\"bootstrap/js/jquery.js\"></script>" + Environment.NewLine +
                   "<script src=\"bootstrap/js/bootstrap.min.js\"></script>" + Environment.NewLine +
                   "<script src=\"ace/ace.js\"></script>" + Environment.NewLine;
        }

        #endregion
    }
}