﻿// MinCMS noninvasive ASP.NET WebForms System
// ----------------------------------------------------
// License: Microsoft Reciprocal License (Ms-RL)
// Version: 1.0.0.0
// Initial Development: Prosodev - Software Company / August 2013 / V 1.0.0.0

namespace MinCms.Core.Ui
{
    using System.Web.UI;

    public class ActivePageIndicator : Control, IMinCmsControlConfiguration
    {
        #region Public Properties

        public string Configuration { get; set; }

        #endregion

        #region Methods

        protected override void Render(HtmlTextWriter writer)
        {
            if (string.IsNullOrEmpty(this.Configuration))
            {
                return;
            }

            var activePage = this.Configuration;
            var activatePageIndicator = "class=\"active\"";
            var items = this.Configuration.Split(';');
            if (items.Length == 2)
            {
                activePage = items[0];
                activatePageIndicator = items[1];
            }

            if (this.Page.Request.AppRelativeCurrentExecutionFilePath == activePage)
            {
                writer.WriteLine(activatePageIndicator);
            }
        }

        #endregion
    }
}