﻿// MinCMS noninvasive ASP.NET WebForms System
// ----------------------------------------------------
// License: Microsoft Reciprocal License (Ms-RL)
// Version: 1.0.0.0
// Initial Development: Prosodev - Software Company / August 2013 / V 1.0.0.0

namespace MinCms.Core.Ui
{
    using System;
    using System.Web.UI;

    public partial class AdminDialogCore : UserControl
    {
        #region Methods

        protected void ButtonCompressDb(object sender, EventArgs e)
        {
            MinCms.Instance.Database.MakeRevision();
        }

        protected void ButtonDeleteDbClicked(object sender, EventArgs e)
        {
            MinCms.Instance.Database.ClearDb();
            this.Response.Redirect("~/default.aspx");
        }

        protected void ButtonRefreshFiles(object sender, EventArgs e)
        {
            MinCms.Instance.ResetFiles();
            MinCms.Instance.CallBackCurrentPage();
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            if (!this.IsPostBack)
            {
                this.ButtonHtmlCompression.InnerText = MinCms.Instance.Properties.GetValue("HtmlCompression", true) ? "Compression (on)" : "Compression (off)";
                this.ButtonEditMode.InnerText = MinCms.Instance.EditMode ? "EditMode (on) " : "EditMode (off)";
            }
        }

        protected void ToggleEditMode(object sender, EventArgs e)
        {
            MinCms.Instance.EditMode = !MinCms.Instance.EditMode;
            MinCms.Instance.CallBackCurrentPage();
        }

        protected void ToggleHtmlCompression(object sender, EventArgs e)
        {
            MinCms.Instance.Properties.SetValue("HtmlCompression", !MinCms.Instance.Properties.GetValue("HtmlCompression", true));
            MinCms.Instance.CallBackCurrentPage();
        }

        #endregion

        protected void OnButtonHome(object sender, EventArgs e)
        {
            MinCms.Instance.DefaultPage = this.Request.ToIFile();
            Response.Redirect("~/default.aspx");
        }

        protected void OnButtonDeletePage(object sender, EventArgs e)
        {
            MinCms.Instance.Database.DeleteFile(this.Request.ToIFile());
            Response.Redirect("~/default.aspx");
        }

        protected void OnButtonCreate(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(this.TextCreate.Value))
            {
                return;
            }

            var template = this.Request.ToIFile();
            if (template.Template != null)
            {
                template = template.Template;
            }

            MinCms.Instance.Database.AddFile(this.TextCreate.Value, template.Url);
            Response.Redirect(this.TextCreate.Value);
        }
    }
}