﻿// MinCMS noninvasive ASP.NET WebForms System
// ----------------------------------------------------
// License: Microsoft Reciprocal License (Ms-RL)
// Version: 1.0.0.0
// Initial Development: Prosodev - Software Company / August 2013 / V 1.0.0.0

namespace MinCms.Core.Ui
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Web.UI;
    using System.Web.UI.WebControls;

    public partial class AdminDialogPlugins : UserControl
    {
        #region Methods

        #endregion

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            this.Repeater1.ItemDataBound += (a, b) =>
            {
                var bd = (AdminDialogPluginBinder) b.Item.DataItem;
                ((Button) b.Item.FindControl("editButton")).CommandArgument = bd.ControlName;
            };

            if (!this.IsPostBack)
            {
                this.Repeater1.DataBind();
            }
        }

        protected void OnConfigureItem(object sender, EventArgs e)
        {
            var plugin = MinCms.Instance.Plugins.First(a => a.GetAdminDisplayName() == ((Button)sender).CommandArgument);
            MinCms.Instance.ExecuteMinCmsPluginConfiguration(plugin);
        }
    }

    public class AdminDialogPluginBinder
    {
        #region Public Properties

        public string ControlName { get; private set; }

        public string Description { get; private set; }

        public string Script { get; set; }

        #endregion

        #region Public Methods and Operators

        public static IEnumerable<AdminDialogPluginBinder> Select()
        {
            var result =
                MinCms.Instance.Plugins.Where(plugin => plugin.AdminPageVisible)
                    .Select(plugin => new AdminDialogPluginBinder {ControlName = plugin.GetAdminDisplayName(), Description = plugin.Description})
                    .ToList();
            return result;
        }

        #endregion
    }
}