﻿// MinCMS noninvasive ASP.NET WebForms System
// ----------------------------------------------------
// License: Microsoft Reciprocal License (Ms-RL)
// Version: 1.0.0.0
// Initial Development: Prosodev - Software Company / August 2013 / V 1.0.0.0

namespace MinCms.Core.Ui
{
    using System;
    using System.Web.UI;

    [ToolboxData("<{0}:MinCmsControl runat=\"server\" />")]
    public sealed class MinCmsControl : Control, IMinCmsControlConfiguration
    {
        #region Public Properties

        public string Configuration { get; set; }

        #endregion

        #region Public Methods and Operators

        public static string GetIncludes(string includeName)
        {
                var val = MinCms.Instance.Properties["MinCmsControl_Configuration",
                    "<!-- DEFAULT -->" + Environment.NewLine +
                    "<meta charset=\"utf-8\">" + Environment.NewLine +
                    "<meta name=\"viewport\" content=\"width=device-width, initial-scale=1.0\">" + Environment.NewLine +
                    "<meta name=\"description\" content=\"\">" + Environment.NewLine +
                    "<meta name=\"author\" content=\"\">" + Environment.NewLine +
                    "<!--[if lt IE 9]>" + Environment.NewLine +
                    "   <script src=\"bootstrap/assets/js/html5shiv.js\"></script>" + Environment.NewLine +
                    "   <script src=\"bootstrap/assets/js/respond.min.js\"></script>" + Environment.NewLine +
                    "<![endif]-->" + Environment.NewLine +
                    "<link href=\"bootstrap/css/bootstrap.min.css\" rel=\"stylesheet\">" + Environment.NewLine +
                    "<script src=\"bootstrap/js/jquery.js\"></script>" + Environment.NewLine +
                    "<script src=\"bootstrap/js/bootstrap.min.js\"></script>" + Environment.NewLine +
                    "<!-- LOCALHOST -->" + Environment.NewLine +
                    "<meta charset=\"utf-8\">" + Environment.NewLine +
                    "<meta name=\"viewport\" content=\"width=device-width, initial-scale=1.0\">" + Environment.NewLine +
                    "<meta name=\"description\" content=\"\">" + Environment.NewLine +
                    "<meta name=\"author\" content=\"\">" + Environment.NewLine +
                    "<!--[if lt IE 9]>" + Environment.NewLine +
                    "   <script src=\"bootstrap/assets/js/html5shiv.js\"></script>" + Environment.NewLine +
                    "   <script src=\"bootstrap/assets/js/respond.min.js\"></script>" + Environment.NewLine +
                    "<![endif]-->" + Environment.NewLine +
                    "<link href=\"bootstrap/css/bootstrap.min.css\" rel=\"stylesheet\">" + Environment.NewLine +
                    "<script src=\"bootstrap/js/jquery.js\"></script>" + Environment.NewLine +
                    "<script src=\"bootstrap/js/bootstrap.min.js\"></script>" + Environment.NewLine +
                    "<script src=\"bootstrap/js/mincms.js\"></script>" + Environment.NewLine +
                    "<script src=\"ace/ace.js\"></script>" + Environment.NewLine +
                    "<!-- EDITMODE -->" + Environment.NewLine +
                    "<meta charset=\"utf-8\">" + Environment.NewLine +
                    "<meta name=\"viewport\" content=\"width=device-width, initial-scale=1.0\">" + Environment.NewLine +
                    "<meta name=\"description\" content=\"\">" + Environment.NewLine +
                    "<meta name=\"author\" content=\"\">" + Environment.NewLine +
                    "<!--[if lt IE 9]>" + Environment.NewLine +
                    "   <script src=\"bootstrap/assets/js/html5shiv.js\"></script>" + Environment.NewLine +
                    "   <script src=\"bootstrap/assets/js/respond.min.js\"></script>" + Environment.NewLine +
                    "<![endif]-->" + Environment.NewLine +
                    "<link href=\"bootstrap/css/bootstrap.min.css\" rel=\"stylesheet\">" + Environment.NewLine +
                    "<script src=\"bootstrap/js/jquery.js\"></script>" + Environment.NewLine +
                    "<script src=\"bootstrap/js/bootstrap.min.js\"></script>" + Environment.NewLine +
                    "<script src=\"bootstrap/js/mincms.js\"></script>" + Environment.NewLine +
                    "<script src=\"ace/ace.js\"></script>" + Environment.NewLine +                    
                    "<script src=\"ckeditor/ckeditor.js\"></script>"
                    ];

            if (!string.IsNullOrEmpty(includeName))
            {
                var index1 = val.IndexOf("<!-- " + includeName.ToUpper() + " -->", StringComparison.Ordinal);
                var index2 = val.IndexOf("<!-- ", index1 + 1, StringComparison.Ordinal);
                if (index2 == -1 && index1 == -1)
                {
                    return string.Empty;
                }

                if (index2 == -1)
                {
                    index2 = val.Length;
                }

                index1 += ("<!-- " + includeName.ToUpper() + " -->").Length;
                var dat = val.Substring(index1, index2 - index1);
                return dat;
            }

            return val;
        }

        #endregion

        #region Methods

        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);
            if (this.Page != null)
            {
                this.Page.PreLoad += (a, b) => this.Page.Form.Controls.Add(this.Page.LoadControl("~/Core/Ui/AdminDialog.ascx"));
            }
        }

        protected override void Render(HtmlTextWriter writer)
        {
            writer.WriteLine(GetIncludes(MinCms.Instance.LocalhostMode ? (MinCms.Instance.EditMode ? "editmode" : "localhost") : "default"));
        }

        #endregion
    }
}