﻿// MinCMS noninvasive ASP.NET WebForms System
// ----------------------------------------------------
// License: Microsoft Reciprocal License (Ms-RL)
// Version: 1.0.0.0
// Initial Development: Prosodev - Software Company / August 2013 / V 1.0.0.0

namespace MinCms.Core.Ui
{
    using System;
    using System.Web;
    using System.Web.UI;

    [ToolboxData("<{0}:MinCmsControlGenerator runat=\"server\" />")]
    public sealed class MinCmsControlGenerator : Control, IMinCmsControlConfiguration
    {
        #region Public Properties

        public string Configuration { get; set; }

        #endregion

        #region Methods

        protected override void OnInit(EventArgs e)
        {
            string[] t;

            this.Configuration = HttpUtility.HtmlDecode(this.Configuration);

            if (this.Configuration.Contains(";"))
            {
                t = new string[2];
                t[0] = this.Configuration.Substring(0, this.Configuration.IndexOf(';'));
                t[1] = this.Configuration.Substring(this.Configuration.IndexOf(';') + 1);
            }
            else
            {
                t = new string[2];
                t[0] = this.Configuration;
                t[1] = string.Empty;
            }

            if (!t[0].ToLower().EndsWith(".ascx"))
            {
                foreach (var a in AppDomain.CurrentDomain.GetAssemblies())
                {
                    var type = a.GetType(t[0]);
                    if (type == null)
                    {
                        continue;
                    }

                    var ctrl = Activator.CreateInstance(type) as Control;

                    if (ctrl != null)
                    {
                        this.Controls.Add(ctrl);

                        var inter = ctrl as IMinCmsControlConfiguration;
                        if (inter != null)
                        {
                            inter.Configuration = t[1];
                        }

                        break;
                    }
                }
            }
            else
            {
                var ctrl = this.Page.LoadControl(t[0]);
                if (ctrl != null)
                {
                    this.Controls.Add(ctrl);

                    var inter = ctrl as IMinCmsControlConfiguration;
                    if (inter != null)
                    {
                        inter.Configuration = t[1];
                    }
                }
            }

            base.OnInit(e);
        }

        #endregion
    }
}