﻿// MinCMS noninvasive ASP.NET WebForms System
// ----------------------------------------------------
// License: Microsoft Reciprocal License (Ms-RL)
// Version: 1.0.0.0
// Initial Development: Prosodev - Software Company / August 2013 / V 1.0.0.0

namespace MinCms.Core.Ui
{
    using System;
    using System.ComponentModel;
    using System.Web.UI;

    public partial class MinCmsEditor : UserControl
    {
        #region Public Events

        public event EventHandler Quit;
        public event EventHandler SaveData;

        #endregion

        #region Public Properties

        [Category("MinCms")]
        public string SaveName
        {
            get { return this.TextBoxSave.Value; }

            set { this.TextBoxSave.Value = value; }
        }

        [Category("MinCms")]
        public string TextData
        {
            get { return this.CoreAceEditor.TextData; }

            set { this.CoreAceEditor.TextData = value; }
        }

        #endregion

        #region Methods

        [Category("MinCms")]
        public bool DisableSaveAs { get; set; }

        protected override void OnPreRender(EventArgs e)
        {
            base.OnPreRender(e);
            if (this.DisableSaveAs)
            {
                this.TextBoxSave.Attributes.Add("disabled", null);
            }
        }

        protected void OnCloseWithSaving(object sender, EventArgs e)
        {
            if (this.SaveData != null)
            {
                this.SaveData(this, new EventArgs());
            }
        }

        protected void OnCloseWithoutSaving(object sender, EventArgs e)
        {
            if (this.Quit != null)
            {
                this.Quit(this, new EventArgs());
            }
        }

        #endregion
    }
}