﻿// MinCMS noninvasive ASP.NET WebForms System
// ----------------------------------------------------
// License: Microsoft Reciprocal License (Ms-RL)
// Version: 1.0.0.0
// Initial Development: Prosodev - Software Company / August 2013 / V 1.0.0.0

namespace MinCms.Core.Ui
{
    using System.Web.UI;

    [ToolboxData("<{0}:MinCmsLinkControl runat=\"server\" />")]
    public sealed class MinCmsLinkControl : Control, IMinCmsControlConfiguration
    {
        #region Public Properties

        public string Configuration { get; set; }

        #endregion

        #region Methods

        protected override void Render(HtmlTextWriter writer)
        {
            if (!string.IsNullOrEmpty(this.Configuration))
            {
                if (this.Configuration.Contains(";"))
                {
                    var s = this.Configuration.Split(';');
                    if (s.Length == 2)
                    {
                        writer.WriteLine("<a href=\"" + this.Page.ResolveUrl(s[0]) + "\">" + s[1] + "</a>");
                    }
                }
                else
                {
                    writer.Write(this.Page.ResolveUrl(this.Configuration));
                }
            }
        }

        #endregion
    }
}