﻿window.onload = function () {
    if (window.addEventListener)
        document.body.addEventListener('dblclick', onDoubleClick, false);
    else if (window.attachEvent)
        document.body.attachEvent('ondblclick', onDoubleClick);
};

function onDoubleClick(ev) {
    var element = ev.target || ev.srcElement;
    var name;
    do {
        element = element.parentNode;
    }
    while (element && (name = element.nodeName.toLowerCase()) &&
        (name != 'div' || element.className.indexOf('editable') == -1) && name != 'body');

    if (name == 'div' && element.className.indexOf('editable') != -1)
        replaceDiv(element);
}

var editor;
var hiddenField;
var transportButton;

function replaceDiv(div) {
    if (editor)
        editor.destroy();

    hiddenField = $(div).next();
    transportButton = $(div).next().next();

    editor = CKEDITOR.replace(div, {
        toolbar: [
            {
                name: 'document',
                groups: ['mode', 'document', 'doctools'],
                items: ['Save MinCms', 'Exit MinCms', 'Source', '-', 'searchCode', 'autoFormat', 'CommentSelectedRange', 'UncommentSelectedRange', 'AutoComplete', '-', 'NewPage', 'Preview', 'Print', '-', 'Templates']
            },
            { name: 'clipboard', groups: ['clipboard', 'undo'], items: ['Cut', 'Copy', 'Paste', 'PasteText', 'PasteFromWord', '-', 'Undo', 'Redo'] },
            { name: 'editing', groups: ['find', 'selection', 'spellchecker'], items: ['Find', 'Replace', '-', 'SelectAll', '-', 'Scayt'] },
            { name: 'forms', items: ['Form', 'Checkbox', 'Radio', 'TextField', 'Textarea', 'Select', 'Button', 'ImageButton', 'HiddenField'] },
            '/',
            { name: 'basicstyles', groups: ['basicstyles', 'cleanup'], items: ['Bold', 'Italic', 'Underline', 'Strike', 'Subscript', 'Superscript', '-', 'RemoveFormat'] },
            { name: 'paragraph', groups: ['list', 'indent', 'blocks', 'align', 'bidi'], items: ['NumberedList', 'BulletedList', '-', 'Outdent', 'Indent', '-', 'Blockquote', 'CreateDiv', '-', 'JustifyLeft', 'JustifyCenter', 'JustifyRight', 'JustifyBlock', '-', 'BidiLtr', 'BidiRtl'] },
            { name: 'links', items: ['Link', 'Unlink', 'Anchor'] },
            { name: 'insert', items: ['Image', 'Flash', 'Table', 'HorizontalRule', 'Smiley', 'SpecialChar', 'PageBreak', 'Iframe'] },
            '/',
            { name: 'styles', items: ['Styles', 'Format', 'Font', 'FontSize'] },
            { name: 'colors', items: ['TextColor', 'BGColor'] },
            { name: 'tools', items: ['Maximize', 'ShowBlocks'] },
            { name: 'about', items: ['About'] }
        ]
    });
}