﻿// MinCMS noninvasive ASP.NET WebForms System
// ----------------------------------------------------
// License: Microsoft Reciprocal License (Ms-RL)
// Version: 1.0.0.0
// Initial Development: Prosodev - Software Company / August 2013 / V 1.0.0.0

namespace MinCms
{
    using System;
    using System.ComponentModel;
    using System.Threading;
    using System.Web.Services;
    using Core;

    [WebService(Namespace = "http://prosodev.com/mincms")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [ToolboxItem(false)]
    public class DatabaseExchange : WebService
    {
        #region Static Fields

        private static readonly object LockObject = new object();

        private static Thread lockThread;

        #endregion

        #region Public Methods and Operators

        [WebMethod]
        public DateTime GetLastUpdate(string accessToken)
        {
            lock (LockObject)
            {
                if (lockThread != null)
                {
                    return DateTime.MinValue;
                }

                if (accessToken != MinCmsHelper.AccessToken)
                {
                    lockThread = new Thread(() =>
                    {
                        Thread.Sleep(20*1000);
                        lockThread = null;
                    });
                    lockThread.Start();
                    return DateTime.MinValue;
                }
            }

            return MinCms.Instance.Database.LastUpdate();
        }

        [WebMethod]
        public void UpdateMinCmsFile(string accessToken, string data)
        {
            lock (LockObject)
            {
                if (lockThread != null)
                {
                    return;
                }

                if (accessToken != MinCmsHelper.AccessToken)
                {
                    lockThread = new Thread(() =>
                    {
                        Thread.Sleep(20*1000);
                        lockThread = null;
                    });
                    lockThread.Start();
                    return;
                }
            }

            MinCms.Instance.Database.SetMinCmsUpdateFile(data);
            MinCms.Instance.ResetFiles();
        }  
        
        [WebMethod]
        public void UpdateMinCmsProperty(string accessToken, string data)
        {
            lock (LockObject)
            {
                if (lockThread != null)
                {
                    return;
                }

                if (accessToken != MinCmsHelper.AccessToken)
                {
                    lockThread = new Thread(() =>
                    {
                        Thread.Sleep(20*1000);
                        lockThread = null;
                    });
                    lockThread.Start();
                    return;
                }
            }

            MinCms.Instance.Database.SetMinCmsUpdateProperty(data);
            MinCms.Instance.ResetFiles();
        }

        #endregion
    }
}